#/* $Header: /home/pat/TclTk/TkfPW-1.2pl1/lib/RCS/batchmode.tcl,v 1.2 1997/10/27 20:21:24 pat Exp pat $ */
#/* $Author: pat $ */
#/* $Date: 1997/10/27 20:21:24 $ */
#/* $Log: batchmode.tcl,v $
#/* Revision 1.2  1997/10/27 20:21:24  pat
#/* Modif des commentaires
#/*
#/* Revision 1.1  1997/10/27 20:18:50  pat
#/* Initial revision
#/* */


proc PrgBatchMode {numproj w} {
# Set up needed widgets in frame w for
# the Batch Mode selection

	# Label

	label $w.lab -text "Set Up the Date"

	# Button for Clean up, Check and Samples

	frame $w.but
	button $w.but.clear -text "Clear" -command [list PrgBatchMode_Clear $w.ent]
	button $w.but.check -text "Check" -command [list PrgBatchMode_CheckDate $w.ent]

	set mb_sample $w.but.sample
	set menu_sample $mb_sample.menu
	menubutton $mb_sample -text {Samples} -menu $menu_sample \
		-relief raised -state normal \
		-underline 0 -disabledforeground {}
	menu $menu_sample -tearoff 0

	PrgBatchMode_MenuSample $menu_sample $w.ent

	pack $w.but.clear $w.but.check $mb_sample -side left

	# Entry for date of run

	entry $w.ent
	bind $w.ent <Return> "$w.but.check flash ; $w.but.check invoke"

	pack $w.lab -side top
	pack $w.ent -side top
	pack $w.but -side top

	$w.ent insert end {See Examples ...}

	return $w.ent
}
proc PrgBatchMode_CheckDate {wentry} {
global env
	PrgBatchMode_UpdateEntryChoice $wentry
	set date [$wentry get]
	set ShellCheckBatchDate $env(TKFPW_HOME)/cmd/CheckBatch.sh
	if [catch {eval exec $ShellCheckBatchDate [list $date] } err] {
        	tk_dialog $wentry.d {TkfPW Error} "Wrong Date :\n<$date>\n$err" error 0 {Try Again !}
		$wentry delete 0 end
	} else {
        	tk_dialog $wentry.d {TkfPW Infos} "Date is Correct :\n<$date> " info 0 {Smile !}
	}
}

proc PrgBatchMode_Clear {w} {
	foreach widget $w {
		catch { $widget delete 0 end }
	}
}

proc PrgBatchMode_UpdateEntryChoice {wentry} {
	$wentry xview end
	$wentry icursor end
}
proc PrgBatchMode_MenuSample_elem {msamples samples wentry} {
	menu $msamples -tearoff 0
	foreach sample $samples {
		$msamples add command -label $sample -command [list PrgBatchMode_SetDateFromMenu $sample $wentry]
	}
}
proc PrgBatchMode_MenuSample {menu_sample wentry} {

	# Implicit Type samples

	$menu_sample add cascade -label {Implicit} -menu $menu_sample.impl -underline 0
	menu $menu_sample.impl -tearoff 0

	set number 0
	foreach type {now today tomorrow} {
	incr number
	$menu_sample.impl add cascade -label "$type + ..." -menu $menu_sample.impl.$number -underline 0
	PrgBatchMode_MenuSample_elem $menu_sample.impl.$number	\
		[list  \
			"$type + # minutes" \
			"$type + # hours" \
			"$type + # days" \
			"$type + # weeks" \
			"$type + # months" \
			"$type + # years" \
		] $wentry
	}

	# Explicit Type samples

	$menu_sample add cascade -label {Explicit} -menu $menu_sample.expl -underline 0
	PrgBatchMode_MenuSample_elem $menu_sample.expl \
		[list  \
			"0815am Jan 24" \
			"5pm Friday" \
			"23:59 Dec 1" \
		] $wentry
	# Mixed Type samples

	$menu_sample add cascade -label {Mixed} -menu $menu_sample.mixed -underline 0
	PrgBatchMode_MenuSample_elem $menu_sample.mixed	\
		[list  \
			"4pm + 3 days" \
			"1am tomorrow" \
		] $wentry
}
proc PrgBatchMode_SetDateFromMenu {date wentry} {
	$wentry delete 0 end
	$wentry insert end $date
	PrgBatchMode_UpdateEntryChoice $wentry
}
